
//declare an object
Car myCar1;
Car myCar2;

void setup() {
  size(200, 200);

  //initialize the object
  // The new operator is used to make a new object.

  myCar1 = new Car(color(255, 0, 0), 0, 100, 2);  //placing arguments inside of the constructor method.
  myCar2 = new Car(color(0, 0, 255), 0, 10, 1);
}

void draw() {
  background(255);

  //call the methods on the object
  // Functions are called with the "dot syntax"
  myCar1.drive();
  myCar1.display();
  myCar2.drive();
  myCar2.display();
}


class Car { //class name

  //data
  color c;
  float xpos;
  float ypos;
  float xspeed;

  // The Constructor is defined with arguments. 
  Car(color tempC, float tempXpos, float tempYpos, float tempXspeed) {
    c = tempC;
    xpos = tempXpos;
    ypos = tempYpos;
    xspeed = tempXspeed;
  }
  void drive() {
    xpos = xpos + xspeed;
    if (xpos > width) {
      xpos = 0;
    }
  }

  void display() {
    fill(c);
    rect(xpos, ypos, 30, 10);
  }
}

